{{
This is the start of a program to control a sprinkler system.

By Steven and computer_guy

}}
CON
  MaxScheduleItems=100 'change this to whatever you want

  'pins that we are using for the clock
  inClk=20    'change these to whatever you are using
  inIO =21
  inCe =22

  rxPin=31
  txPin=30
  mode=0
  baudrate=9600

  _clkmode = xtal1 + pll16x
  _xinfreq = 6_000_000




OBJ
  eeprom : "Propeller Eeprom"
  clock  : "DS1302"
  text   : "TV_Text"
  ser    : "FullDuplexSerial"

VAR
  long schedule[MaxScheduleItems]
  byte NumScheduleItems

  long start1Running
  long start2Running
  long start3Running
  long start4Running
  long start5Running
  long start6Running
  long start7Running
  long start8Running

'Format for schedule items is
'byte day
'byte hours
'byte minutes
'byte control instruction
'Which comes to 1 long
  
PUB start|i,currentTime,checkTime
'to be finished at some stage
  'Just so that I can see what it is doing. You can comment it out if you want
  text.start(24)
  text.str(string("Hi!!"))

  'Setup the clock
  clock.init(inClk,inIO,inCe)
  clock.config
  setTestTime
  currentTime:=getTime
  text.str(string(13,"Launch Time: "))
  printRealTime(currentTime)

  ser.start(rxpin, txpin, mode, baudrate)

  text.str(string(13,"Finished setup"))

  'Insert a dummy item
  'insertItem(newItem(1,23,24,start1))
  'insertItem(newItem(1,23,40,stop1))
  printSchedule
  
  'We need to check for serial input and check the time in here
  'If either occures we need to call the appropiate function
  'One of the methods from the serial will need to be setting the clocks

  repeat
    'get the time
    currentTime:=getTime  'Change this to getTime for the real thing
    'printTime(currentTime)
    'go through all the items in the schedule
    repeat i from 0 to NumScheduleItems-1
      'get item from the schedule and blank out the control instruction
      checkTime:=schedule[i]
      checkTime.byte[3]:=0
      'if the same do the instruction
      if currentTime==checkTime
        checkTime:=schedule[i]
        doInstruction(checkTime.byte[3])
      'should probable have a waitcnt in here to save some power
      'waitcnt(cnt)     'You can uncomment this if you want
    checkSerial

  'These two methods are use to save and get the schedule from the eeprom
PUB getSchedule 'We probably won't actuall need this method but it was easy to write it so here it is
  eeprom.VarRestore(@schedule[0],@schedule[NumScheduleItems-1])

PUB backupSchedule
  eeprom.VarBackup(@NumScheduleItems,@NumScheduleItems+1)
  eeprom.VarBackup(@schedule[0],@schedule[NumScheduleItems])
  
PUB insertItem(item)
'This adds a schedule item to the list
  schedule[NumScheduleItems]:=item
  NumScheduleItems:=NumScheduleItems+1
  printSchedule
  backupSchedule

PUB newItem(day,hours,minutes,instruction):item
  'This returns a long which is in the right format
  'and turns the hours and minutes into BCD
  item.byte[0]:=day
  item.byte[1]:=(hours/10)<<4+hours//10
  item.byte[2]:=(minutes/10)<<4+minutes//10
  item.byte[3]:=instruction

PUB printTime(time)
  text.str(string(13,"Time "))
  text.hex(time.byte[1]>>4,1)
  text.hex(time.byte[1],1)
  text.out(":")
  text.hex(time.byte[2]>>4,1)
  text.hex(time.byte[2],1)

  text.str(string(",  Day "))
  case time.byte[0]
    0: text.str(string("Sunday"))
    1: text.str(string("Monday"))
    2: text.str(string("Tuesday"))
    3: text.str(string("Wednesday"))
    4: text.str(string("Thursday"))
    5: text.str(string("Friday"))
    6: text.str(string("Saturday"))

  text.str(string(", Code "))
  text.hex(time.byte[3],2) 
PUB printRealTime(time)
  text.hex(time.byte[1]>>4,1)
  text.hex(time.byte[1],1)
  text.out(":")
  text.hex(time.byte[2]>>4,1)
  text.hex(time.byte[2],1)

  text.str(string(",  Day "))
  case time.byte[0]
    0: text.str(string("Sunday"))
    1: text.str(string("Monday"))
    2: text.str(string("Tuesday"))
    3: text.str(string("Wednesday"))
    4: text.str(string("Thursday"))
    5: text.str(string("Friday"))
    6: text.str(string("Saturday"))

  'text.str(string(", Code "))
  'text.hex(time.byte[3],2) 
PUB printSchedule|i
  text.str(string(1,$B,2))
  repeat i from 0 to NumScheduleItems-1
    printTime(schedule[i])
CON
  'some suggested codes - this is just an enumeration so that we don't have to rember a whole heap
  'of numbers
  start1 = 00
  stop1  = 01
  
  start2 = 02
  stop2  = 03

  start3 = 04
  stop3  = 05

  start4 = 06
  stop4  = 07

  start5 = 08
  stop5  = 09
  
  start6 = 10
  stop6  = 11

  start7 = 12
  stop7  = 13

  start8 = 14
  stop8  = 15

  pin1=4
  pin2=5
  pin3=6
  pin4=7
  pin5=8
  pin6=9
  pin7=10
  pin8=11
  
PUB doInstruction(instruction)
  'This will turn on/off whatever pin or do whatever else we want to do
  'Could even hoopup one of the timers so that we could get a PWM output
  case instruction
    start1:
      if start1Running == false
        start1Running:=true
        outa[pin1]~
        text.str(string(13,"called code start1"))
    stop1:
      if start1Running == true
        start1Running:=false
        outa[pin1]~~
        text.str(string(13,"called code stop1"))
    start2:
      if start2Running == false
        start2Running:=true
        outa[pin2]~
        text.str(string(13,"called code start2"))
    stop2:
      if start2Running == true
         start2Running:=false
         outa[pin2]~~
         text.str(string(13,"called code stop2"))
    start3:
      if start3Running == false
        start3Running:=true
        outa[pin3]~
        text.str(string(13,"called code start3"))
    stop3:
      if start3Running == true
         start3Running:=false
         outa[pin3]~~
         text.str(string(13,"called code stop3"))
    start4:
      if start4Running == false
        start4Running:=true
        outa[pin4]~
        text.str(string(13,"called code start4"))
    stop4:
      if start4Running == true
         start4Running:=false
         outa[pin4]~~
         text.str(string(13,"called code stop4"))
    start5:
      if start5Running == false
        start5Running:=true
        outa[pin5]~
        text.str(string(13,"called code start5"))
    stop5:
      if start5Running == true
         start5Running:=false
         outa[pin6]~~
         text.str(string(13,"called code stop5"))
    start6:
      if start6Running == false
        start6Running:=true
        outa[pin6]~
        text.str(string(13,"called code start6"))
    stop6:
      if start6Running == true
         start6Running:=false
         outa[pin6]~~
         text.str(string(13,"called code stop6"))
    start7:
      if start7Running == false
        start7Running:=true
        outa[pin7]~
        text.str(string(13,"called code start7"))
    stop7:
      if start7Running == true
         start7Running:=false
         outa[pin7]~~
         text.str(string(13,"called code stop7"))
    start8:
      if start8Running == false
        start8Running:=true
        outa[pin8]~
        text.str(string(13,"called code start8"))
    stop8:
      if start8Running == true
         start8Running:=false
         outa[pin8]~~
         text.str(string(13,"called code stop8"))

PUB getTime:time|temp
  clock.readDate(@temp,@temp,@temp,@time.byte[0])
  clock.readTime(@time.byte[1],@time.byte[2],@temp)

PUB getTestTime:time
  time:=newItem(1,23,24,0)
PUB setTestTime
clock.setDatetime( 02, 13, 2008, 03, 09, 37, 00 )
CON
  sendSchedule="s"     'I changed these so that they would be more different
  recieveItem="n"
  clearList="c"
  recieveTime="t"  

PUB checkSerial|temp
  temp:=ser.rxCheck
  case temp
    sendSchedule:
      sendDataSerial
    recieveItem:
      getItemSerial
    clearList:
      NumScheduleItems:=0
      eeprom.VarBackup(@NumScheduleItems,@NumScheduleItems+1)
    recieveTime:
      getTimeSerial

PUB getItemSerial
  insertItem(newItem(ser.rx,ser.rx,ser.rx,ser.rx))
  backupSchedule

PUB getTimeSerial
  clock.setDateTime(ser.rx,ser.rx,ser.rx,ser.rx,ser.rx,ser.rx,ser.rx)
  backupSchedule
  
PUB sendDataSerial|i,time,data
  data := (NumScheduleItems/10)<<4+NumScheduleItems//10
  ser.tx(data)'So that you know how many items there are
  repeat i from 0 to NumScheduleItems-1
    time:=schedule[i]
    ser.tx(time.byte[0])
    ser.tx((time.byte[1]/10)<<4+time.byte[1]//10)
    ser.tx((time.byte[2]/10)<<4+time.byte[2]//10)
    ser.tx(time.byte[3])
    'ser.str(string(10,13,"Time "))
    'ser.hex(time.byte[1]>>4,1)
    'ser.hex(time.byte[1],1)
    'ser.str(string(":"))
    'ser.hex(time.byte[2]>>4,1)
    'ser.hex(time.byte[2],1)

    'ser.str(string(",  Day "))
    'case time.byte[0]
      '0: ser.str(string("Sunday"))
      '1: ser.str(string("Monday"))
      '2: ser.str(string("Tuesday"))
      '3: ser.str(string("Wednesday"))
      '4: ser.str(string("Thursday"))
      '5: ser.str(string("Friday"))
      '6: ser.str(string("Saturday"))

    'ser.str(string(", Code "))
    'ser.hex(time.byte[3],2) 
     